<template>
  <div :class="{ 'edit-mode': editMode }">
    <div class="inner">
      <div id="app">
        {{ isRoutingLoaded }}
        <template v-if="isRoutingLoaded">
          <router-view/>
        </template>
        <template v-else>
          Loading... [[ spinner? ]]
        </template>
      </div>
      <editable-sidebar id="sidebar" v-if="isRoutingLoaded && editMode && isEditableSidebarLoaded"></editable-sidebar>
    </div>
  </div>
</template>

<script>
// import Vue from 'vue'

import { WITH_SOURCES } from '@/config'
// import css from '∂'

import { AppStarterMixin } from 'y3ti-i3'
import { SetRoutesMixin } from 'y3ti-r3'

// import _ from 'lodash'

// import { pushRoutes } from '@/router/utils'

// import { mapActions, mapGetters } from 'vuex'

// import EditableSidebar from '@/components/Editable/Sidebar/SidebarEditable'

export default {
  mixins: [AppStarterMixin, SetRoutesMixin],

  name: 'App',

  components: {
    // EditableSidebar: () => import('@/components/Editable/Sidebar/SidebarEditable')
  },

  data () {
    return {
      isEditableSidebarLoaded: false
    }
  },

  watch: {
    editMode () {
      this.handleCSS()
    }
  },

  methods: {
    handleCSS () {
      if (this.editMode && !this.isEditableSidebarLoaded) {
        if (WITH_SOURCES) {
          this.isEditableSidebarLoaded = true
        } else {
          import(/* webpackChunkName: "i3-css" */ 'Y3TII3_CSS').then(() => {
            this.isEditableSidebarLoaded = true
          })
        }
      }
    }
  },

  // computed: {
  //   ...mapGetters({
  //     editMode: 'Y3TI/editMode',
  //     routingStatus: 'Y3TI/routingStatus',
  //     userStatus: 'Y3TI/userStatus'
  //   }),

  //   isLoaded () {
  //     return this.routingStatus !== 'loading'
  //   }
  // },

  // methods: {
  //   ...mapActions({
  //     unsetEditableActiveZone: 'Y3TI/unsetEditableActiveZone',
  //     setAltPressed: 'Y3TI/setAltPressed',
  //     unsetAltPressed: 'Y3TI/unsetAltPressed',
  //     getRouting: 'Y3TI/getRouting',
  //     getUser: 'Y3TI/getUser'
  //   }),

  //   handleEsc: _.debounce(function () {
  //     if (this.editMode) {
  //       this.unsetEditableActiveZone({ data: { id: '*' } })
  //     }
  //     this.$nextTick(() => {
  //       document.activeElement.blur()
  //     })
  //   }, 200, { leading: true, trailing: false }),
  //   // handleAltDown: _.debounce(function () {
  //   //   this.setAltPressed()
  //   // }, 200, { leading: true, trailing: false }),

  //   handleAltDown () {
  //     if (!this.altPressed) {
  //       this.altPressed = true
  //       this.setAltPressed()
  //     }
  //   },

  //   handleAltUp () {
  //     this.altPressed = false
  //     this.unsetAltPressed()
  //   },

  //   keydownEvent (e) {
  //     if (e.key === 'Escape' || e.key === 'Esc' || e.keyCode === 27) {
  //       // const dropzones = document.getElementsByClassName('dropzone')
  //       // console.log('dropzones', dropzones)
  //       // _.each(dropzones, (elem) => {
  //       //   elem.classList.remove('dragging')
  //       // })
  //       this.handleEsc()
  //     } else if (e.key === 'Alt' || e.keyCode === 18) {
  //       this.handleAltDown()
  //     }
  //   },

  //   keyupEvent (e) {
  //     if (e.key === 'Alt' || e.keyCode === 18) {
  //       this.handleAltUp()
  //     }
  //   }
  // },

  // mounted () {
  //   window.addEventListener('keyup', this.keyupEvent)
  //   window.addEventListener('keydown', this.keydownEvent)
  // },

  // beforeDestroy () {
  //   window.removeEventListener('keyup', this.keyupEvent)
  //   window.removeEventListener('keydown', this.keydownEvent)
  // },

  // created () {
  // this.handleCSS()
  // console.log('this.$i3Mixins', this.$i3Mixins)
  // }

  created () {
    this.handleCSS()
    this.getUser()
    this.setRoutes(this.pushNewNodeRoutes)
  }
}
</script>

<style lang="scss">
  html {
    height: 100%;
  }
  body, html {
    min-height: 100%;
    margin: 0;
    padding: 0;
  }

  :root {
    --ck-spacing-unit:           inherit; // 0.6em;
 //  --ck-spacing-large:           calc(var(--ck-spacing-unit) * 1.5);
 //  --ck-spacing-standard:          var(--ck-spacing-unit);
 //  --ck-spacing-medium:          calc(var(--ck-spacing-unit) * 0.8);
 //  --ck-spacing-small:           calc(var(--ck-spacing-unit) * 0.5);
 //  --ck-spacing-tiny:            calc(var(--ck-spacing-unit) * 0.3);
 //  --ck-spacing-extra-tiny:        calc(var(--ck-spacing-unit) * 0.16);
  }

</style>
